%if 0%{?fedora} || 0%{?rhel} == 6
%global with_devel 1
%global with_bundled 0
%global with_debug 0
# cyclic dependency between golang-github-smartystreets-goconvey and
# golang-github-smartystreets-assertions
%global with_check 0
%global with_unit_test 1
%else
%global with_devel 0
%global with_bundled 0
%global with_debug 0
%global with_check 0
%global with_unit_test 0
%endif

%if 0%{?with_debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%global provider        github
%global provider_tld    com
%global project         smartystreets
%global repo            goconvey
# https://github.com/smartystreets/goconvey
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     %{provider_prefix}
%global commit          bf58a9a1291224109919756b4dcc469c670cc7e4
%global shortcommit     %(c=%{commit}; echo ${c:0:7})

Name:           golang-%{provider}-%{project}-%{repo}
Version:        1.6.1
Release:        0.1.git%{shortcommit}%{?dist}
Summary:        Behavioral testing in the browser, integrates with go test
License:        MIT
URL:            https://%{provider_prefix}
Source0:        https://%{provider_prefix}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz

# e.g. el6 has ppc64 arch without gcc-go, so EA tag is required
ExclusiveArch:  %{?go_arches:%{go_arches}}%{!?go_arches:%{ix86} x86_64 %{arm}}
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires:  %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}

%description
%{summary}

%if 0%{?with_devel}
%package devel
Summary:       %{summary}
BuildArch:     noarch

%if 0%{?with_check}
# cyclic dependency between golang-github-smartystreets-goconvey and
# golang-github-smartystreets-assertions
BuildRequires: golang(github.com/jtolds/gls)
BuildRequires: golang(github.com/smartystreets/assertions)
%endif

Requires:      golang(github.com/jtolds/gls)
Requires:      golang(github.com/smartystreets/assertions)
Provides:      golang(%{import_path}/convey) = %{version}-%{release}
Provides:      golang(%{import_path}/convey/gotest) = %{version}-%{release}
Provides:      golang(%{import_path}/convey/reporting) = %{version}-%{release}
Provides:      golang(%{import_path}/web/server/api) = %{version}-%{release}
Provides:      golang(%{import_path}/web/server/contract) = %{version}-%{release}
Provides:      golang(%{import_path}/web/server/executor) = %{version}-%{release}
Provides:      golang(%{import_path}/web/server/messaging) = %{version}-%{release}
Provides:      golang(%{import_path}/web/server/parser) = %{version}-%{release}
Provides:      golang(%{import_path}/web/server/system) = %{version}-%{release}
Provides:      golang(%{import_path}/web/server/watch) = %{version}-%{release}
Provides:      golang(%{import_path}/web/server/watch/integration_testing/sub) = %{version}-%{release}

%description devel
%{summary}

This package contains library source intended for
building other packages which use import path with
%{import_path} prefix.
%endif

%if 0%{?with_unit_test}
%package unit-test
Summary:         Unit tests for %{name} package

%if 0%{?with_check}
#Here comes all BuildRequires: PACKAGE the unit tests
#in %%check section need for running
%endif

# test subpackage tests code from devel subpackage
Requires:        %{name}-devel = %{version}-%{release}

%description unit-test
%{summary}

This package contains unit tests for project
providing packages with %{import_path} prefix.
%endif

%prep
%setup -q -n %{repo}-%{commit}

%build

%install
# source codes for building projects
%if 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
echo "%%dir %%{gopath}/src/%%{import_path}/." >> devel.file-list
# find all *.go but no *_test.go files and generate devel.file-list
for file in $(find . -iname "*.go" \! -iname "*_test.go") ; do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done
%endif

# testing files for this project
%if 0%{?with_unit_test}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
# find all *_test.go files and generate unit-test.file-list
for file in $(find . -iname "*_test.go"); do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> unit-test.file-list
done
%endif

%if 0%{?with_devel}
sort -u -o devel.file-list devel.file-list
%endif

%check
%if 0%{?with_check} && 0%{?with_unit_test} && 0%{?with_devel}
%if ! 0%{?with_bundled}
export GOPATH=%{buildroot}/%{gopath}:%{gopath}
%else
export GOPATH=%{buildroot}/%{gopath}:$(pwd)/Godeps/_workspace:%{gopath}
%endif

%if ! 0%{?gotest:1}
%global gotest go test
%endif

%gotest %{import_path}/convey
%gotest %{import_path}/convey/reporting
%gotest %{import_path}/web/server/api
%gotest %{import_path}/web/server/executor
%gotest %{import_path}/web/server/parser
%gotest %{import_path}/web/server/system
%gotest %{import_path}/web/server/watch
%gotest %{import_path}/web/server/watch/integration_testing/sub
%endif

#define license tag if not already defined
%{!?_licensedir:%global license %doc}

%if 0%{?with_devel}
%files devel -f devel.file-list
%license LICENSE.md
%doc README.md CONTRIBUTING.md
%dir %{gopath}/src/%{provider}.%{provider_tld}/%{project}
%endif

%if 0%{?with_unit_test}
%files unit-test -f unit-test.file-list
%license LICENSE.md
%doc README.md CONTRIBUTING.md
%endif

%changelog
* Thu Apr 14 2016 jchaloup <jchaloup@redhat.com> - 1.6.1-0.1.gitbf58a9a
- Bump to upstream bf58a9a1291224109919756b4dcc469c670cc7e4
  Polish the spec file
  related: #1250511

* Mon Feb 22 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-0.5.git43652d6
- https://fedoraproject.org/wiki/Changes/golang1.6

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0-0.4.git43652d6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Mon Aug 17 2015 jchaloup <jchaloup@redhat.com> - 0-0.3.git43652d6
- Add missing BRs
  related: #1250511

* Mon Aug 10 2015 Fridolin Pokorny <fpokorny@redhat.com> - 0-0.2.git43652d6
- Update spec file to spec-2.0
  resolves: #1250511

* Thu Apr 16 2015 jchaloup <jchaloup@redhat.com> - 0-0.1.git43652d6
- First package for Fedora
  resolves: #1214862

